/*
Scripts

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapi

import (
	"encoding/json"
)

// checks if the StartScriptRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &StartScriptRequest{}

// StartScriptRequest struct for StartScriptRequest
type StartScriptRequest struct {
	ConversationId string `json:"conversation_id"`
	TransactionId *string `json:"transaction_id,omitempty"`
	Language *string `json:"language,omitempty"`
	Reference *string `json:"reference,omitempty"`
	MessageTags []string `json:"message_tags,omitempty"`
	StaticData map[string]interface{} `json:"static_data,omitempty"`
	DynamicData map[string]interface{} `json:"dynamic_data,omitempty"`
	InteractionId *string `json:"interaction_id,omitempty"`
}

// NewStartScriptRequest instantiates a new StartScriptRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewStartScriptRequest(conversationId string) *StartScriptRequest {
	this := StartScriptRequest{}
	this.ConversationId = conversationId
	return &this
}

// NewStartScriptRequestWithDefaults instantiates a new StartScriptRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewStartScriptRequestWithDefaults() *StartScriptRequest {
	this := StartScriptRequest{}
	return &this
}

// GetConversationId returns the ConversationId field value
func (o *StartScriptRequest) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *StartScriptRequest) SetConversationId(v string) {
	o.ConversationId = v
}

// GetTransactionId returns the TransactionId field value if set, zero value otherwise.
func (o *StartScriptRequest) GetTransactionId() string {
	if o == nil || IsNil(o.TransactionId) {
		var ret string
		return ret
	}
	return *o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetTransactionIdOk() (*string, bool) {
	if o == nil || IsNil(o.TransactionId) {
		return nil, false
	}
	return o.TransactionId, true
}

// HasTransactionId returns a boolean if a field has been set.
func (o *StartScriptRequest) HasTransactionId() bool {
	if o != nil && !IsNil(o.TransactionId) {
		return true
	}

	return false
}

// SetTransactionId gets a reference to the given string and assigns it to the TransactionId field.
func (o *StartScriptRequest) SetTransactionId(v string) {
	o.TransactionId = &v
}

// GetLanguage returns the Language field value if set, zero value otherwise.
func (o *StartScriptRequest) GetLanguage() string {
	if o == nil || IsNil(o.Language) {
		var ret string
		return ret
	}
	return *o.Language
}

// GetLanguageOk returns a tuple with the Language field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetLanguageOk() (*string, bool) {
	if o == nil || IsNil(o.Language) {
		return nil, false
	}
	return o.Language, true
}

// HasLanguage returns a boolean if a field has been set.
func (o *StartScriptRequest) HasLanguage() bool {
	if o != nil && !IsNil(o.Language) {
		return true
	}

	return false
}

// SetLanguage gets a reference to the given string and assigns it to the Language field.
func (o *StartScriptRequest) SetLanguage(v string) {
	o.Language = &v
}

// GetReference returns the Reference field value if set, zero value otherwise.
func (o *StartScriptRequest) GetReference() string {
	if o == nil || IsNil(o.Reference) {
		var ret string
		return ret
	}
	return *o.Reference
}

// GetReferenceOk returns a tuple with the Reference field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetReferenceOk() (*string, bool) {
	if o == nil || IsNil(o.Reference) {
		return nil, false
	}
	return o.Reference, true
}

// HasReference returns a boolean if a field has been set.
func (o *StartScriptRequest) HasReference() bool {
	if o != nil && !IsNil(o.Reference) {
		return true
	}

	return false
}

// SetReference gets a reference to the given string and assigns it to the Reference field.
func (o *StartScriptRequest) SetReference(v string) {
	o.Reference = &v
}

// GetMessageTags returns the MessageTags field value if set, zero value otherwise.
func (o *StartScriptRequest) GetMessageTags() []string {
	if o == nil || IsNil(o.MessageTags) {
		var ret []string
		return ret
	}
	return o.MessageTags
}

// GetMessageTagsOk returns a tuple with the MessageTags field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetMessageTagsOk() ([]string, bool) {
	if o == nil || IsNil(o.MessageTags) {
		return nil, false
	}
	return o.MessageTags, true
}

// HasMessageTags returns a boolean if a field has been set.
func (o *StartScriptRequest) HasMessageTags() bool {
	if o != nil && !IsNil(o.MessageTags) {
		return true
	}

	return false
}

// SetMessageTags gets a reference to the given []string and assigns it to the MessageTags field.
func (o *StartScriptRequest) SetMessageTags(v []string) {
	o.MessageTags = v
}

// GetStaticData returns the StaticData field value if set, zero value otherwise.
func (o *StartScriptRequest) GetStaticData() map[string]interface{} {
	if o == nil || IsNil(o.StaticData) {
		var ret map[string]interface{}
		return ret
	}
	return o.StaticData
}

// GetStaticDataOk returns a tuple with the StaticData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetStaticDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.StaticData) {
		return map[string]interface{}{}, false
	}
	return o.StaticData, true
}

// HasStaticData returns a boolean if a field has been set.
func (o *StartScriptRequest) HasStaticData() bool {
	if o != nil && !IsNil(o.StaticData) {
		return true
	}

	return false
}

// SetStaticData gets a reference to the given map[string]interface{} and assigns it to the StaticData field.
func (o *StartScriptRequest) SetStaticData(v map[string]interface{}) {
	o.StaticData = v
}

// GetDynamicData returns the DynamicData field value if set, zero value otherwise.
func (o *StartScriptRequest) GetDynamicData() map[string]interface{} {
	if o == nil || IsNil(o.DynamicData) {
		var ret map[string]interface{}
		return ret
	}
	return o.DynamicData
}

// GetDynamicDataOk returns a tuple with the DynamicData field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetDynamicDataOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.DynamicData) {
		return map[string]interface{}{}, false
	}
	return o.DynamicData, true
}

// HasDynamicData returns a boolean if a field has been set.
func (o *StartScriptRequest) HasDynamicData() bool {
	if o != nil && !IsNil(o.DynamicData) {
		return true
	}

	return false
}

// SetDynamicData gets a reference to the given map[string]interface{} and assigns it to the DynamicData field.
func (o *StartScriptRequest) SetDynamicData(v map[string]interface{}) {
	o.DynamicData = v
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *StartScriptRequest) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *StartScriptRequest) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *StartScriptRequest) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *StartScriptRequest) SetInteractionId(v string) {
	o.InteractionId = &v
}

func (o StartScriptRequest) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o StartScriptRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["conversation_id"] = o.ConversationId
	if !IsNil(o.TransactionId) {
		toSerialize["transaction_id"] = o.TransactionId
	}
	if !IsNil(o.Language) {
		toSerialize["language"] = o.Language
	}
	if !IsNil(o.Reference) {
		toSerialize["reference"] = o.Reference
	}
	if !IsNil(o.MessageTags) {
		toSerialize["message_tags"] = o.MessageTags
	}
	if !IsNil(o.StaticData) {
		toSerialize["static_data"] = o.StaticData
	}
	if !IsNil(o.DynamicData) {
		toSerialize["dynamic_data"] = o.DynamicData
	}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	return toSerialize, nil
}

type NullableStartScriptRequest struct {
	value *StartScriptRequest
	isSet bool
}

func (v NullableStartScriptRequest) Get() *StartScriptRequest {
	return v.value
}

func (v *NullableStartScriptRequest) Set(val *StartScriptRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableStartScriptRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableStartScriptRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableStartScriptRequest(val *StartScriptRequest) *NullableStartScriptRequest {
	return &NullableStartScriptRequest{value: val, isSet: true}
}

func (v NullableStartScriptRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableStartScriptRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


